
header \<open>Additional material concerning polynomial mappings\<close>

theory Poly_Mapping_additional
imports "../Poly_Mapping"
begin

text \<open>Attempt for complete transfer setup\<close>

lift_definition poly_mapping_rel :: "('a \<Rightarrow> 'b \<Rightarrow> bool) \<Rightarrow> ('c \<Rightarrow> 'd \<Rightarrow> bool)
  \<Rightarrow> ('a, 'c::zero) poly_mapping \<Rightarrow> ('b, 'd::zero) poly_mapping \<Rightarrow> bool"
  is "rel_fun"
  .

lemma [relator_eq]:
  "poly_mapping_rel HOL.eq HOL.eq = HOL.eq"
  apply (rule ext)+
  apply transfer
  apply (simp add: fun_eq_iff rel_fun_def)
  done

lemma [relator_mono]:
  "C \<le> A \<Longrightarrow> B \<le> D \<Longrightarrow> poly_mapping_rel A B \<le> poly_mapping_rel C D"
  apply (rule le_funI)+
  apply transfer
  apply (drule fun_mono)
  apply auto
  done

(*lemma [relator_distr]:
  "poly_mapping_rel R S OO poly_mapping_rel R' S' \<le> poly_mapping_rel (R OO R') (S OO S')"
  "left_unique R \<Longrightarrow> right_total R \<Longrightarrow> right_unique R' \<Longrightarrow> left_total R'
    \<Longrightarrow> poly_mapping_rel (R OO R') (S OO S') \<le> poly_mapping_rel R S OO poly_mapping_rel R' S'"
  "right_unique R' \<Longrightarrow> left_total R' \<Longrightarrow> left_unique S' \<Longrightarrow> right_total S'
    \<Longrightarrow> poly_mapping_rel (R OO R') (S OO S') \<le> poly_mapping_rel R S OO poly_mapping_rel R' S'"
  apply (rule le_funI)+
  apply transfer apply auto[1] defer
  apply (rule le_funI)+
  apply transfer apply auto[1] defer
  apply (rule le_funI)+
  apply transfer apply auto[1] sorry*)

end