(* Author: Andreas Lochbihler, ETH Zurich
   Author: Florian Haftmann, TU Muenchen 
*)

theory Test
imports MPoly_Impl Complex_Main
begin

definition p01 :: "rat mpoly"
where
  "p01 = M' (DISTR RLEX) [2, 1] (3 / 5) + M' (DISTR RLEX) [0, 3] (7 / 3) + M' (DISTR RLEX) [1, 1] 1"

definition p02 :: "rat mpoly"
where
  "p02 = M' (DISTR RLEX) [2, 7, 1] (4 / 5) + M' (DISTR RLEX) [] 2"

definition p03 :: "rat mpoly"
where
  "p03 = M' (DISTR RLEX) [2] 7 + M' (DISTR RLEX) [0, 3] (- 4)"

subsection \<open>Degree etc\<close>
declare [[code abort: Poly_Mapping.keys]]
value
  "degree (monom_distr (Nat_Mapping.single' DENSE 0 1) 2 +
           monom_distr (Nat_Mapping.single' DENSE 0 4) 3 :: int mpoly) 0"

subsection \<open>Addition\<close>
value "p01 + p02"

value "p01 + p03"

value "p02 + p03"

value "p01 + p02 + p03"

subsection \<open>Multiplication\<close>
(*value "smult 42 p01"

value "smult 0 p02"

value "smult (- 7 / 8) p03"

value "p01 * p02"

value "p01 * p03"

value "p02 * p03"

value "p01 * p02 * p03"*)

subsection \<open>Multiplication recursive dense\<close>
definition p0002003 :: "int mpoly" --\<open>recursive dense\<close>
where "p0002003 = 
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 3) 2 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 6) 3  "
definition p1002003 :: "int mpoly" --\<open>recursive dense\<close>
where "p1002003 = 
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 0) 1 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 3) 2 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 6) 3  "
definition p45 :: "int mpoly" --\<open>recursive dense\<close>
where "p45 = 
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 0) 4 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 5  "
definition p0002003_45 :: "int mpoly" --\<open>recursive dense\<close>
where "p0002003_45 = 
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 3) 8 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 4) 10 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 6) 12 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 7) 15"
definition p1002003_45 :: "int mpoly" --\<open>recursive dense\<close>
where "p1002003_45 = 
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 0) 4 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 5 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 3) 8 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 4) 10 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 6) 12 +
  monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 7) 15"
definition "assert_p0002003_45 \<longleftrightarrow> p0002003 * p45 = p0002003_45"
(* ML {* @{assert} @{code assert_p0002003_45} *}
   ERROR Type int mpoly not of sort equal       *)
value "p0002003 * p45" --\<open>= "Rec (Powers (Dense (Abs_nat_mapping_dense [
  Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 12, Coeff 15])))"\<close>

definition "assert_p1002003_45 \<longleftrightarrow> p1002003 * p45 = p1002003_45"
(* ML {* @{assert} @{code assert_p1002003_45} *}
   ERROR Type int mpoly not of sort equal       *)
value "p1002003 * p45" --\<open>= "Rec (Powers (Dense (Abs_nat_mapping_dense [
  Coeff 4, Coeff 5, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 12, Coeff 15])))"\<close>


definition p7z :: "int mpoly" --\<open>(*=== 10.x^2.y^2.z^2 ===*)\<close>
where "p7z = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 2) 1 *
             monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 2) 1 *
             monom' (REC DENSE) (Nat_Mapping.single' DENSE 3 2) 10"
value "p7z" --\<open>= "Rec (Powers (Dense (Abs_nat_mapping_dense [ (* mult works for monom' too *)
  Coeff 0, Coeff 0,
  Powers (Dense (Abs_nat_mapping_dense [
    Coeff 0, Coeff 0, 
    Powers (Dense (Abs_nat_mapping_dense [Powers (Dense (Abs_nat_mapping_dense [
      Coeff 0, Coeff 0, Coeff 10]))]))]))])))"\<close>
definition px :: "int mpoly" --\<open>(*=== 3.z^3          ===*)\<close>
where "px = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 3) 3"
value "px * p7z" --\<open>= CORRECT: "Rec (Powers (Dense (Abs_nat_mapping_dense [
  Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 0,
  Powers (Dense (Abs_nat_mapping_dense [
    Coeff 0, Coeff 0, 
    Powers (Dense (Abs_nat_mapping_dense [
      Powers (Dense (Abs_nat_mapping_dense [
        Coeff 0, Coeff 0, Coeff 30]))]))]))])))"\<close>


definition p2x3y :: "int mpoly" --\<open>recursive dense\<close>
where "p2x3y = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 2 +
               monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 1) 3"
definition p4x5y :: "int mpoly" --\<open>recursive dense\<close>
where "p4x5y = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 4 +
               monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 1) 5"
definition p2x3y_4x5y :: "int mpoly" --\<open>recursive dense\<close>
where "p2x3y_4x5y = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 2) 8 +
                    monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 1  *
                    monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 1) 22  +
                    monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 2) 15"
value p2x3y_4x5y --\<open>= "Rec (Powers (Dense (Abs_nat_mapping_dense [
  Powers (Dense (Abs_nat_mapping_dense [Coeff 0, Coeff 0, Coeff 15])), 
  Powers (Dense (Abs_nat_mapping_dense [Coeff 0, Coeff 22])), 
  Coeff 8])))"\<close>
value "p2x3y * p4x5y" --\<open>= CORRECT: "Rec (        (* (R[x])[y] *)
  Powers (Dense (Abs_nat_mapping_dense [           (* y^0. *)
    Powers (Dense (Abs_nat_mapping_dense [         (* y^0.(... *)
      Coeff 0, Coeff 0, Coeff 15])),               (*      x^0.0 + x^1.0 + x^2. 15) *)
    Powers (Dense (Abs_nat_mapping_dense [         (* y^1.(... *)
      Coeff 0, Coeff 22])),                        (*      x^0.0 + x^1.22) *)
    Coeff 8])))"                                   (* y^2. x^0.8 *) 
                                                   (* -------------------------------  *)
                                                   (* OK:      8.y^2 + 22.x.y + 15.x^2 *)\<close>

definition p2x3y4z :: "int mpoly" --\<open>(*=== 1 + 2.z + 3.y + 4.x ===*)\<close>
where "p2x3y4z = monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 0) 1 +
                 monom' (REC DENSE) (Nat_Mapping.single' DENSE 0 1) 4 +
                 monom' (REC DENSE) (Nat_Mapping.single' DENSE 1 1) 3 +
                 monom' (REC DENSE) (Nat_Mapping.single' DENSE 2 1) 2"
value "p2x3y4z" --\<open>= "Rec (Powers (Dense (Abs_nat_mapping_dense [
  Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [Coeff 1, Coeff 2])), Coeff 3])), Coeff 4])))"
= 1 + 2.x + 3.y + 4.z\<close>
value "p2x3y4z * p2x3y4z" --\<open>= "Rec (             (* (R[x,y])[z] *)
  Powers (Dense (Abs_nat_mapping_dense [           (* *)
    Powers (Dense (Abs_nat_mapping_dense [         (* z^0. *)
      Powers (Dense (Abs_nat_mapping_dense [       (* z^0.y^0.(... *)
        Coeff 1, Coeff 4, Coeff 4])),              (*          x^0.1 + x^1.4 + x^2.4) *)
      Powers (Dense (Abs_nat_mapping_dense [       (* z^0.y^1.(... *)
        Coeff 6, Coeff 12])),                      (*          x^0.6 + x^1.12) *)
      Coeff 9])),                                  (* z^0.y^2. x^0.9 *)
    Powers (Dense (Abs_nat_mapping_dense [         (* z^1. *)
      Powers (Dense (Abs_nat_mapping_dense [       (* z^1.y^0.(... *)
        Coeff 8, Coeff 16])),                      (*          x^0.8 + x^1.16) *)
      Coeff 24])),                                 (* z^1.y^1. x^0.24          *)
    Coeff 16])))"                                  (* z^2.y^0. x^0.16          *) 
= 1 + 4.x + 4.x^2 + 6.y + 12.xy + 9.y^2 + 8.z + 16.xz + 24.yz + 16.z^2\<close>

value
  "monom_distr (Nat_Mapping.single' DENSE 0 1) 2 :: int mpoly"   -- "2*X^1"
  
value
  "monom_distr (Nat_Mapping.single' SPARSE 0 4) 3 :: int mpoly" -- "3*X^4"

value
  "monom_distr (Nat_Mapping.single' SPARSE 0 1) 2 +
   monom_distr (Nat_Mapping.single' SPARSE 0 4) 3 :: int mpoly" -- "2*X^1 + 3*X^4"

value
  "monom_distr (Nat_Mapping.single' DENSE 0 1) 2 +
   monom_distr (Nat_Mapping.single' DENSE 0 4) 3 :: int mpoly"

subsection \<open>Multiplication recursive sparse\<close>
definition ps0002003 :: "int mpoly" --\<open>recursive dense\<close>
where "ps0002003 = 
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 3) 2 +
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 6) 3  "
value ps0002003 --\<open>= "Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (Suc (Suc (Suc 0)), Coeff 2), 
  (Suc (Suc (Suc (Suc (Suc (Suc 0))))), Coeff 3)] )))"\<close>

definition ps45 :: "int mpoly" --\<open>recursive dense\<close>
where "ps45 = 
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 0) 4 +
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 1) 5  "
value ps45 --\<open>= "Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (0, Coeff 4), 
  (Suc 0, Coeff 5)] )))"\<close>

definition ps0002003_45 :: "int mpoly" --\<open>recursive dense\<close>
where "ps0002003_45 = 
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 3) 8 +
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 4) 10 +
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 6) 12 +
  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 7) 15"
value ps0002003_45 --\<open>= "Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (Suc (Suc (Suc 0)), Coeff 8), 
  (Suc (Suc (Suc (Suc 0))), Coeff 10), 
  (Suc (Suc (Suc (Suc (Suc (Suc 0))))), Coeff 12), 
  (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))), Coeff 15)]) ))"\<close>
(*    ^^^ = vvv : this multiplication is correct *)
value "ps0002003 * ps45" --\<open>= "Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (Suc (Suc (Suc 0)), Coeff 8), 
  (Suc (Suc (Suc (Suc 0))), Coeff 10), 
  (Suc (Suc (Suc (Suc (Suc (Suc 0))))), Coeff 12), 
  (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))), Coeff 15)] )))"\<close>

(* cf some DENSE tests here for SPARSE omitted *)

definition ps2x3y4z :: "int mpoly" --\<open>(*=== 1 + 2.z + 3.y + 4.x ===*)\<close>
where "ps2x3y4z = monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 0) 1 +
                  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 0 1) 4 +
                  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 1 1) 3 +
                  monom' (REC SPARSE) (Nat_Mapping.single' SPARSE 2 1) 2"
value "ps2x3y4z" --\<open>= "Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (0, Powers (Sparse (Abs_nat_mapping_sparse [
    (0, Powers (Sparse (Abs_nat_mapping_sparse [
      (0, Coeff 1), 
    (Suc 0, Coeff 2)]))), 
  (Suc 0, Coeff 3)]))), 
(Suc 0, Coeff 4)])))"\<close>
(*    ^^^ = vvv : this multiplication is correct *)
value "ps2x3y4z * ps2x3y4z" --\<open>"Rec (Powers (Sparse (Abs_nat_mapping_sparse [
  (0, Powers (Sparse (Abs_nat_mapping_sparse [
    (0, Powers (Sparse (Abs_nat_mapping_sparse [
      (0, Coeff 1), 
      (Suc 0, Coeff 4), 
      (Suc (Suc 0), Coeff 4)] ))),
    (Suc 0, Powers (Sparse (Abs_nat_mapping_sparse [
      (0, Coeff 6), 
      (Suc 0, Coeff 12)] ))), 
  (Suc (Suc 0), Coeff 9)] ))),
  (Suc 0, Powers (Sparse (Abs_nat_mapping_sparse [
    (0, Powers (Sparse (Abs_nat_mapping_sparse [
      (0, Coeff 8), 
      (Suc 0, Coeff 16)] ))), 
    (Suc 0, Coeff 24)] ))), 
(Suc (Suc 0), Coeff 16)] )))"
??? = 1 + 4.x + 4.x^2 + 6.y + 12.xy + 9.y^2 + 8.z + 16.xz + 24.yz + 16.z^2\<close>

(*
value
  "monom_distr (Nat_Mapping.single' DENSE 0 1) 2 +
   monom_distr (Nat_Mapping.single' SPARSE 0 4) 3 :: int mpoly" 
   -- "raises Fail because representations are mixed"
*)
 
subsection \<open>Division\<close>
  

end
